var oGlobalEnabler=null;

Ext.define('DSS.addon.HLEEdit.GridPanel',
{

	extend : 'Ext.grid.Panel',

	config : {
		enableColumnHide : false,
		enableColumnMove : false,
		selType : 'rowmodel',
		viewConfig : {
			forceFit : true
		}
	},

	/** The event store */
	store : null,
	editorWindow : null,
	curSelectedEvent : null,
	btnNew:null,
	btnEdit:null,
	btnDelete:null,
	btnDisable:null,
	btnEnable:null,
	btnTest:null,
	
	
	/** DSS JSon class */
	property : 'DSS.json.Property',


	constructor : function(config) {
		
		var me=this;

		oGlobalEnabler=function (name,state)
		{
			if (!state)
			{
				dss.raiseEvent('hle-config',{actions:'disable','name':name})
				me.waitAndReload();
			} else {
				dss.raiseEvent('hle-config',{actions:'enable','name':name})
				me.waitAndReload();
			}
		},
		
		this.initConfig(config);
		this.property = Ext.create(this.property, config);
		
		this.btnNew=new Ext.create('Ext.button.Button',{
			text : _('New HLE'),
			iconCls : 'icon-add-action',
			handler : function() {
				me.curSelectedEvent = null;
				me.editorWindow.setValues(null);
				me.editorWindow.show();
			}
		});
		this.btnEdit=new Ext.create('Ext.button.Button',{
			text : _('Edit HLE'),
			iconCls : 'icon-edit-action',
			disabled : true,
			handler : function() {
				var oParams={};
				oParams.name=me.curSelectedEvent.get('name');
				oParams.actions=me.curSelectedEvent.get('action');
				me.editorWindow.setValues(oParams);
				me.editorWindow.show();
			}
		});
		this.btnDelete=new Ext.create('Ext.button.Button',{
			text : _('Delete HLE'),
			iconCls : 'icon-delete-action',
			disabled : true,
			handler : function() {
				dss.raiseEvent('hle-config',{actions:'delete',name:me.curSelectedEvent.get('name')})
				me.waitAndReload();
			}
		});
		this.btnDisable=new Ext.create('Ext.button.Button',{
			text : _('Disable HLE'),
			iconCls : 'icon-disable-action',
			disabled : true,
			handler : function() {
				dss.raiseEvent('hle-config',{actions:'disable',name:me.curSelectedEvent.get('name')})
				me.waitAndReload();
			}
		});
		this.btnEnable=new Ext.create('Ext.button.Button',{
			text : _('Enable HLE'),
			iconCls : 'icon-enable-action',
			hidden: true,
			disabled : true,
			handler : function() {
				dss.raiseEvent('hle-config',{actions:'enable',name:me.curSelectedEvent.get('name')})
				me.waitAndReload();
			}
		});
		this.btnTest=new Ext.create('Ext.button.Button',{
			text : _('HLE Ausf&uuml;hren'),
			iconCls : 'icon-test-action',
			disabled : true,
			handler : function() {				
				dss.raiseEvent('highlevelevent',{name:me.curSelectedEvent.get('name')});
				
				window.setTimeout(function (){me.loadParameter(me);},2*1000);
			}

		});
		
		Ext.apply(this, {
			tbar : {
				items : [ this.btnNew, this.btnEdit, this.btnDisable, this.btnEnable,this.btnTest, '->', this.btnDelete ]}
		});
				
		this.callParent(arguments);
	},	
	waitAndReload:function() {
		var me=this;
		var iSubscriptID=Math.floor(Math.random() * 100000000000);
		dss.ajaxSyncRequest('/json/event/subscribe',{subscriptionID:iSubscriptID,name:'hle-saved'});
		dss.ajaxAssyncRequestWithoutAnswer('/json/event/get',{subscriptionID:iSubscriptID,timeout:60*1000},
		function (){
			me.loadParameter();
			dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe',{subscriptionID:iSubscriptID,name:'hle-saved'});
		});
	},	


	loadParameter:function(me){
		if (me==null)
			me=this;
		dss.staticDataModel.initHLECache();
		var sString = dss.ajaxSyncRequest('/json/property/query',
			{
				'query' : '/usr/events/*(*)/*(mist)/*(*)'
			});
		var result=Ext.JSON.decode(sString);
		if (result.ok)		
			if (result.result!=null)
				if (result.result.events!=null) {
					var oArray=[];
					for (var iIndex=0;iIndex<result.result.events.length;iIndex++)
					{
						var oObject={};
						oObject.name=result.result.events[iIndex].name;
						oObject.disabled=result.result.events[iIndex].disabled;
						oObject.action=[];
						oObject.lastSaved=result.result.events[iIndex].lastSaved;
						oObject.lastExecuted=result.result.events[iIndex].lastExecuted;
						for(var iKey in result.result.events[iIndex])
							if (typeof(result.result.events[iIndex][iKey])=="object")
							{
								var aArray=result.result.events[iIndex][iKey];
								for (var jIndex=0;jIndex<aArray.length;jIndex++)
								{
									if (aArray[jIndex].actions!=null)
									{
										for (var kIndex=0;kIndex<aArray[jIndex].actions.length;kIndex++) {
											var resultObject=aArray[jIndex].actions[kIndex];
											var oActionObject={};
											for (var oKey in resultObject){
												oActionObject[oKey]=resultObject[oKey];	
											}
											
											oObject.action.push(oActionObject);
										}
										
									}
								}
							}
						oArray.push(oObject);				
					}
					me.store.removeAll();
					me.store.add(oArray);				
				}
	},
	initComponent : function() {
		var me = this;

		me.store = Ext.create('Ext.data.Store', {
			storeId : 'hleStore',
			fields : [ 'disabled','name','action','lastSaved','lastExecuted' ],
			proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
		});

		var editorConfig = me.config;
		editorConfig.title = 'HLE bearbeiten';
		editorConfig.staticControls = [{
			type : 'text',
			label : _('HLE Name'),
			id : 'name'
		}];
		editorConfig.tabControls = [ {
			tabLabel : 'Auszuf&uuml;hrende Handlung',
			content : [ {
				type : 'ActionConfigurator',
				id : 'actions'
			} ]
		}, {
			tabLabel : 'Bedingungen',
			content : [  ]
		} ];
		me.editorWindow = Ext.create(
				'DSS.addon.HLEEditor', editorConfig);
		me.on({selectionchange : function(view,
							selections, options) {
						var me = this;
						if (selections.length > 0) {
							me.curSelectedEvent = selections[0];
							me.btnEdit.setDisabled(false);
							me.btnDelete.setDisabled(false);
							me.btnDisable.setDisabled(me.curSelectedEvent.get('disabled'));
							me.btnDisable.setVisible(!me.curSelectedEvent.get('disabled'));
							me.btnEnable.setDisabled(!me.curSelectedEvent.get('disabled'));
							me.btnEnable.setVisible(me.curSelectedEvent.get('disabled'));
							me.btnTest.setDisabled(me.curSelectedEvent.get('disabled'));
						} else {
							me.curSelectedEvent = null;
							me.btnEdit.setDisabled(true);
							me.btnDelete.setDisabled(true);
							me.btnDisable.setDisabled(true);
							me.btnEnable.setDisabled(true);
							me.btnEnable.setVisible(false);
							me.btnTest.setDisabled(true);
						}
					}
				});
		me.editorWindow.on({
			'save': function (oValue)
			{
				dss.raiseEvent('hle-config',{actions:'save',value:Ext.JSON.encode(oValue)})
				me.waitAndReload();
			}
		})
		me.callParent(arguments);
		me.initPage();
		me.loadParameter();
	}, // initComponent

	initPage : function() {
		var me = this, aptStore = null, onAptStoreLoaded = function() {

		};

		var aptStore = DSS.types.ActionModel.getApartmentStore();
		if (aptStore.isLoading()) {
			me.setLoading(true);
			aptStore.on('load', onAptStoreLoaded);
		} else {
			onAptStoreLoaded();
		}
	},

	viewConfig : {
		stripeRows : true
	},
	
	columns : [ 
			{
				id : 'col-status',
				header : _('Active'),
				dataIndex : 'disabled',
				renderer : function(val, metadata, record,
						colIdx, store, view) {
					return '<input type="checkbox" onclick="oGlobalEnabler(\'' + record.get('name') + '\','+record.get('disabled')+');"' + (!record.get('disabled') ? ' checked="true" >' : '>');
				},
				resizable : false,
				width : 50
			},
			{
				id : 'col-name',
				header : _('Name'),
				dataIndex : 'name',
				width : 200
			},
			{
				id : 'col-actions',
				header : _('Action'),
				dataIndex : 'id', // alibi index
				maintainFlex : true,
				flex : 5,
				sortable : false,
				renderer : function (val, metadata, record,
						colIdx, store, view)
						{
							var oRecord=record.get('action');
							var sResult="<table>";
							
							for (var iIndex=0;iIndex<oRecord.length;iIndex++) {
								var oAction=oRecord[iIndex];
								sResult+="<tr>";
								switch (oAction.type) {
									case 'zone-scene': { // scene, group,zone,force
										var sString =  '<td style="padding-right:5px;">'+ dss.staticDataModel.getImageForScene(
														oAction.zone,
														oAction.group,
														oAction.scene) + "</td>";
							
										sString += "<td>"
												+ dss.staticDataModel.getNameForScene(
														oAction.zone,
														oAction.group,
														oAction.scene);
										if (oAction.group!=0)
											sString +=" f&uuml;r " + dss.staticDataModel.getNameForGroup(oAction.zone, oAction.group);
										if (oAction.zone!=0)
											sString+= " in " + dss.staticDataModel.getNameForZone(oAction.zone);
										if (oAction.force)
											sString += ' !';
										sString += "</td>";
										sResult+=sString;
										break;
									}
									case 'device-scene': {// scene, dsid,force
										var oDevice = dss.staticDataModel
												.getDevice(oAction.dsid);
									
										var sString = oDevice.name + " in ";
										sString += dss.staticDataModel
												.getNameForZone(oDevice.ZoneID);
										if (oAction.force)
											sString += ' !';
							
										if (oAction.scene==13) {// aus
											sString='<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice)+ '"></td><td>' 
												+ sString + " ausschalten</td>"; 
										} else if (oAction.scene==14) {// ein
											sString='<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice)+ '"></td><td>' 
											+ sString + " einschalten</td>"; 
									    } else if (oAction.scene==51) { // ein loc
											sString='<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice)+  '"></td><td>' 
											+ sString + " einschalten mit Lokalpriorit&auml;t</td>"; 
										} else {
											sString='<td style="padding-right:5px;">'
												+ dss.staticDataModel.getImageForScene(oDevice.ZoneID, oDevice.GroupID,oAction.scene) + "</td><td>"
												+ dss.staticDataModel.getNameForScene(oDevice.ZoneID, oDevice.GroupID,oAction.scene)
												+ " f&uuml;r "+ sString + "</td>"	
										}			
										sResult+=sString;
						
										break;
									}
									case 'device-value': { // value, dsid
										var oDevice = dss.staticDataModel
												.getDevice(oAction.dsid);
										var sString = '<td colspan="2">'
												+ Math.round(oAction.value / 2.55)
												+ "% f&uuml;r ";
										sString += oDevice.name + " in ";
										sString += dss.staticDataModel
												.getNameForZone(oDevice.ZoneID);
										sString += "</td>";
										sResult+=sString;
						
										break;
									}
									case 'device-blink': {// dsid
										var oDevice = dss.staticDataModel
												.getDevice(oAction.dsid);
										var sString = '<td style="padding-right:5px;"><img src="'+
										dss.staticDataModel.getImageForDevice(oDevice)+ '"></td>';
										sString +="<td>" + oDevice.name
												+ " in ";
										sString += dss.staticDataModel
												.getNameForZone(oDevice.ZoneID);
										sString += " blinkt</td>";
										sResult+=sString;
										break;
									}
									case 'zone-blink': {// group,zone
										var sString = '<td style="padding-right:5px;"><img src="images/sceneIcons/scene_blink.png"></td>';
										sString +="<td>" +  dss.staticDataModel.getNameForGroup(
												oAction.zone, oAction.group)
												+ " in ";
										sString += dss.staticDataModel
												.getNameForZone(oAction.zone);
										sString += " blinkt</td>";
										sResult+=sString;
										break;
									}
									case 'custom-event': { // event
										sResult+='<td colspan="2">Highlevel Event: ' + oAction.event + '</td>';
										break;
									}
									case 'url': { // url
										sResult+='<td colspan="2">URL: ' + oAction.url + '</td>';
										break;
									}
								}
								sResult+="</tr>";
							}
							return sResult+"</table>";
						}
			},{
				id : 'col-changed',
				header : _('Bearbeitet am'),
				dataIndex : 'lastSaved',
				renderer : function (val, metadata, record, colIdx, store, view)
					{
						if (record.get('lastSaved')=="") {
							return _('-');
						} else {
							var oRecord=record.get('lastSaved');
							var oDate=new Date();
							oDate.setTime(parseInt(oRecord));
							return pad(oDate.getDate()) + "." + pad(oDate.getMonth()+1) + "." + oDate.getFullYear() + " - " +
								pad(oDate.getHours()) + ":" + pad(oDate.getMinutes()) + ":" + pad(oDate.getSeconds());
						}
					},
				width : 200
			},{
				id : 'col-executed',
				header : _('zuletzt ausgef&uuml;hrt'),
				dataIndex : 'lastExecuted',
				renderer : function (val, metadata, record, colIdx, store, view)
					{
						if (record.get('lastExecuted')=="") {
							return _('-');
						} else {
							var oRecord=record.get('lastExecuted');
							var oDate=new Date();
							oDate.setTime(parseInt(oRecord));
							return pad(oDate.getDate()) + "." + pad(oDate.getMonth()+1) + "." + oDate.getFullYear() + " - " +
								pad(oDate.getHours()) + ":" + pad(oDate.getMinutes()) + ":" + pad(oDate.getSeconds());
						}
					},
				width : 200
			}, 
			
    ]	
});

Ext.define('DSS.addon.HLEEditor', {
	extend : 'DSS.component.Editor'
});

function pad(c) {
	var i = parseInt(c, 10);
	return (i < 10 ? '0' + i : c.toString());
}

